var NAVTREE =
[
  [ "jaula API Reference", "index.html", [
    [ "Main Page", "index.html", null ],
    [ "Modules", "modules.html", [
      [ "JAULA: General definitions", "group__jaula__gen.html", [
        [ "Namespaces", "group__jaula__gen.html", [
          [ "JAULA", "namespaceJAULA.html", null ]
        ] ]
      ] ],
      [ "JAULA: Error handling", "group__jaula__exc.html", [
        [ "Functions", "group__jaula__exc.html", [
          [ "operator<<", "group__jaula__exc.html#ga22e72bb9f96630655cedbaed228a5a5a", null ]
        ] ],
        [ "Data Structures", "group__jaula__exc.html", [
          [ "JAULA::Bad_Data_Type", "classJAULA_1_1Bad__Data__Type.html", null ],
          [ "JAULA::Exception", "classJAULA_1_1Exception.html", null ],
          [ "JAULA::Lexan_Error", "classJAULA_1_1Lexan__Error.html", null ],
          [ "JAULA::Name_Duplicated", "classJAULA_1_1Name__Duplicated.html", null ],
          [ "JAULA::No_Error", "classJAULA_1_1No__Error.html", null ],
          [ "JAULA::Syntax_Error", "classJAULA_1_1Syntax__Error.html", null ]
        ] ]
      ] ],
      [ "JAULA: JSON lexical analysis", "group__jaula__lex.html", [
        [ "Data Structures", "group__jaula__lex.html", [
          [ "JAULA::Lexan", "classJAULA_1_1Lexan.html", null ]
        ] ]
      ] ],
      [ "JAULA: JSON data parser", "group__jaula__parse.html", [
        [ "Data Structures", "group__jaula__parse.html", [
          [ "JAULA::Parser", "classJAULA_1_1Parser.html", null ],
          [ "JAULA::Parser::Value_Parser", "classJAULA_1_1Parser_1_1Value__Parser.html", null ]
        ] ]
      ] ],
      [ "JAULA: JSON Values containers", "group__jaula__val.html", [
        [ "Functions", "group__jaula__val.html", [
          [ "operator<<", "group__jaula__val.html#ga657456c1e05143dcfd3eb8677cc49bf8", null ]
        ] ],
        [ "Data Structures", "group__jaula__val.html", [
          [ "JAULA::Value", "classJAULA_1_1Value.html", null ],
          [ "JAULA::Value_Array", "classJAULA_1_1Value__Array.html", null ],
          [ "JAULA::Value_Boolean", "classJAULA_1_1Value__Boolean.html", null ],
          [ "JAULA::Value_Complex", "classJAULA_1_1Value__Complex.html", null ],
          [ "JAULA::Value_Null", "classJAULA_1_1Value__Null.html", null ],
          [ "JAULA::Value_Number", "classJAULA_1_1Value__Number.html", null ],
          [ "JAULA::Value_Number_Int", "classJAULA_1_1Value__Number__Int.html", null ],
          [ "JAULA::Value_Object", "classJAULA_1_1Value__Object.html", null ],
          [ "JAULA::Value_String", "classJAULA_1_1Value__String.html", null ]
        ] ]
      ] ]
    ] ],
    [ "Data Structures", "annotated.html", [
      [ "JAULA::Bad_Data_Type", "classJAULA_1_1Bad__Data__Type.html", null ],
      [ "JAULA::Exception", "classJAULA_1_1Exception.html", null ],
      [ "JAULA::Lexan", "classJAULA_1_1Lexan.html", null ],
      [ "JAULA::Lexan_Error", "classJAULA_1_1Lexan__Error.html", null ],
      [ "JAULA::Name_Duplicated", "classJAULA_1_1Name__Duplicated.html", null ],
      [ "JAULA::No_Error", "classJAULA_1_1No__Error.html", null ],
      [ "JAULA::Parser", "classJAULA_1_1Parser.html", null ],
      [ "JAULA::Parser::Value_Parser", "classJAULA_1_1Parser_1_1Value__Parser.html", null ],
      [ "JAULA::Syntax_Error", "classJAULA_1_1Syntax__Error.html", null ],
      [ "JAULA::Value", "classJAULA_1_1Value.html", null ],
      [ "JAULA::Value_Array", "classJAULA_1_1Value__Array.html", null ],
      [ "JAULA::Value_Boolean", "classJAULA_1_1Value__Boolean.html", null ],
      [ "JAULA::Value_Complex", "classJAULA_1_1Value__Complex.html", null ],
      [ "JAULA::Value_Null", "classJAULA_1_1Value__Null.html", null ],
      [ "JAULA::Value_Number", "classJAULA_1_1Value__Number.html", null ],
      [ "JAULA::Value_Number_Int", "classJAULA_1_1Value__Number__Int.html", null ],
      [ "JAULA::Value_Object", "classJAULA_1_1Value__Object.html", null ],
      [ "JAULA::Value_String", "classJAULA_1_1Value__String.html", null ]
    ] ],
    [ "Data Structure Index", "classes.html", null ],
    [ "Class Hierarchy", "hierarchy.html", [
      [ "JAULA::Exception", "classJAULA_1_1Exception.html", [
        [ "JAULA::Bad_Data_Type", "classJAULA_1_1Bad__Data__Type.html", null ],
        [ "JAULA::Lexan_Error", "classJAULA_1_1Lexan__Error.html", null ],
        [ "JAULA::Name_Duplicated", "classJAULA_1_1Name__Duplicated.html", null ],
        [ "JAULA::No_Error", "classJAULA_1_1No__Error.html", null ],
        [ "JAULA::Syntax_Error", "classJAULA_1_1Syntax__Error.html", null ]
      ] ],
      [ "JAULA::Lexan", "classJAULA_1_1Lexan.html", null ],
      [ "JAULA::Parser", "classJAULA_1_1Parser.html", null ],
      [ "JAULA::Parser::Value_Parser", "classJAULA_1_1Parser_1_1Value__Parser.html", null ],
      [ "JAULA::Value", "classJAULA_1_1Value.html", [
        [ "JAULA::Value_Boolean", "classJAULA_1_1Value__Boolean.html", null ],
        [ "JAULA::Value_Complex", "classJAULA_1_1Value__Complex.html", [
          [ "JAULA::Value_Array", "classJAULA_1_1Value__Array.html", null ],
          [ "JAULA::Value_Object", "classJAULA_1_1Value__Object.html", null ]
        ] ],
        [ "JAULA::Value_Null", "classJAULA_1_1Value__Null.html", null ],
        [ "JAULA::Value_Number", "classJAULA_1_1Value__Number.html", null ],
        [ "JAULA::Value_Number_Int", "classJAULA_1_1Value__Number__Int.html", null ],
        [ "JAULA::Value_String", "classJAULA_1_1Value__String.html", null ]
      ] ]
    ] ],
    [ "Data Fields", "functions.html", null ],
    [ "Namespace List", "namespaces.html", [
      [ "JAULA", "namespaceJAULA.html", null ]
    ] ],
    [ "File List", "files.html", [
      [ "jaula.h", null, null ],
      [ "jaula_bad_data_type.h", null, null ],
      [ "jaula_exception.h", null, null ],
      [ "jaula_lexan.h", null, null ],
      [ "jaula_lexan_error.h", null, null ],
      [ "jaula_name_duplicated.h", null, null ],
      [ "jaula_no_error.h", null, null ],
      [ "jaula_parse.h", null, null ],
      [ "jaula_syntax_error.h", null, null ],
      [ "jaula_value.h", null, null ],
      [ "jaula_value_array.h", null, null ],
      [ "jaula_value_boolean.h", null, null ],
      [ "jaula_value_complex.h", null, null ],
      [ "jaula_value_null.h", null, null ],
      [ "jaula_value_number.h", null, null ],
      [ "jaula_value_number_int.h", null, null ],
      [ "jaula_value_object.h", null, null ],
      [ "jaula_value_string.h", null, null ]
    ] ]
  ] ]
];

function createIndent(o,domNode,node,level)
{
  if (node.parentNode && node.parentNode.parentNode)
  {
    createIndent(o,domNode,node.parentNode,level+1);
  }
  var imgNode = document.createElement("img");
  if (level==0 && node.childrenData)
  {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() 
    {
      if (node.expanded) 
      {
        $(node.getChildrenUL()).slideUp("fast");
        if (node.isLast)
        {
          node.plus_img.src = node.relpath+"ftv2plastnode.png";
        }
        else
        {
          node.plus_img.src = node.relpath+"ftv2pnode.png";
        }
        node.expanded = false;
      } 
      else 
      {
        expandNode(o, node, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
  }
  else
  {
    domNode.appendChild(imgNode);
  }
  if (level==0)
  {
    if (node.isLast)
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2plastnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2lastnode.png";
        domNode.appendChild(imgNode);
      }
    }
    else
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2pnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2node.png";
        domNode.appendChild(imgNode);
      }
    }
  }
  else
  {
    if (node.isLast)
    {
      imgNode.src = node.relpath+"ftv2blank.png";
    }
    else
    {
      imgNode.src = node.relpath+"ftv2vertline.png";
    }
  }
  imgNode.border = "0";
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  a.appendChild(node.label);
  if (link) 
  {
    a.href = node.relpath+link;
  } 
  else 
  {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
      node.expanded = false;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() 
  {
    if (!node.childrenUL) 
    {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
}

function expandNode(o, node, imm)
{
  if (node.childrenData && !node.expanded) 
  {
    if (!node.childrenVisited) 
    {
      getNode(o, node);
    }
    if (imm)
    {
      $(node.getChildrenUL()).show();
    } 
    else 
    {
      $(node.getChildrenUL()).slideDown("fast",showRoot);
    }
    if (node.isLast)
    {
      node.plus_img.src = node.relpath+"ftv2mlastnode.png";
    }
    else
    {
      node.plus_img.src = node.relpath+"ftv2mnode.png";
    }
    node.expanded = true;
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) 
  {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
        i==l);
  }
}

function findNavTreePage(url, data)
{
  var nodes = data;
  var result = null;
  for (var i in nodes) 
  {
    var d = nodes[i];
    if (d[1] == url) 
    {
      return new Array(i);
    }
    else if (d[2] != null) // array of children
    {
      result = findNavTreePage(url, d[2]);
      if (result != null) 
      {
        return (new Array(i).concat(result));
      }
    }
  }
  return null;
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;

  getNode(o, o.node);

  o.breadcrumbs = findNavTreePage(toroot, NAVTREE);
  if (o.breadcrumbs == null)
  {
    o.breadcrumbs = findNavTreePage("index.html",NAVTREE);
  }
  if (o.breadcrumbs != null && o.breadcrumbs.length>0)
  {
    var p = o.node;
    for (var i in o.breadcrumbs) 
    {
      var j = o.breadcrumbs[i];
      p = p.children[j];
      expandNode(o,p,true);
    }
    p.itemDiv.className = p.itemDiv.className + " selected";
    p.itemDiv.id = "selected";
    $(window).load(showRoot);
  }
}

